// 
// Anpassungen im makefile:
//    ATMega8 => MCU=atmega8 im makefile einstellen ATTiny2313 = attiny2313
//    lcd-routines.c in SRC = ... Zeile anhngen
//  IT WOOOOOORKS!!! (LCD) (UART) (PS2 routines I completely had to write myself)
// ok attiny2313 pins used: d0 (RXD=pin1) d1 (txd=pin2) d3 (RTS=pin7) d5 (ps2data=pin9) d6 (ps2clk=Pin11)
//so pins left on port d (just call ps2_golo to light) are: 2(=pin 6), 4(=pin 8), 7(not exist). or use portb which is on the right side of the C and conveniently numbered 0 (pin 12) to 7 (pin 20)
//ah and ISP connections are MOSI Pin 17 MISO Pin 18 and SCK Pin 19 (VCC GND and Reset ommitted)
#include <avr/io.h>
#define BAUD 1200
#include <util/setbaud.h>
#include <stdlib.h>
#include <util/delay.h>

//#include "lcd.h"
#include "ps2.h" //TODO: translate ps2.h and ps2.cpp for WinAVR - just need to replace the macros like PinMode. and probably DigitalRead/Write

/* UART-Init Bsp. ATmega16 */
 
void uart_init(void) //hmmm seems to be different on attiny2313, because here is where it's hanging.
{
   UBRRH = UBRRH_VALUE;
   UBRRL = UBRRL_VALUE;
 
  UCSRB |= (1<<TXEN);  						// UART TX einschalten
  //UCSRC = (1<<URSEL)|(1<<UCSZ1)|(1<<UCSZ0);  // Asynchron 8N1 
  UCSRC = /*(1<<URSEL)|*/(1<<UCSZ1);  			  // Asynchron 7N1 URSEL MUSS in Atmega8 gesetzt sein!
  UCSRB |= (1<<RXEN);                       // UART RX einschalten
  //UCSRC = (3<<UCSZ0);        // 8 bit (default: asynchronous, no parity, (not gonna work with Mouse, but Term?

}

/* ATmega16 */
int uart_putc(unsigned char c)
{
    while (!(UCSRA & (1<<UDRE)))  /* warten bis Senden moeglich */
    {
    }                             
 
    UDR = c;                      /* sende Zeichen */
    return 0;
}
 
 
/* puts ist unabhaengig vom Controllertyp */
void uart_puts (char *s)
{
    while (*s)
    {   /* so lange *s != '\0' also ungleich dem "String-Endezeichen(Terminator)" */
        uart_putc(*s);
        s++;
    }
}

uint8_t uart_getc(void)
{
    while (!(UCSRA & (1<<RXC)));   // warten bis Zeichen verfuegbar
    return UDR;                   // Zeichen aus UDR an Aufrufer zurueckgeben
}

uint8_t uart_kbhit(void)
{
	if((UCSRA & (1<<RXC))) return uart_getc(); //if a \0 has been sent, the program will misinterpret it as "no char sent"
	return 0;
}


 
int main(void)
{
  // Initialisierung des LCD
  // Nach der Initialisierung mssen auf dem LCD vorhandene schwarze Balken
  // verschwunden sein
  uint32_t devid;
  char c;
  char x;
  char y;
  uint8_t st;
  uint8_t out;
  char click;
  uint8_t resolution;
  uint8_t warhigh;
  //char Buffer[4];
	uint8_t a=0;
/*  uint8_t chrdata0[8] = { //mouse cursor.
        0b00010000,
        0b00011000,
        0b00010100,
        0b00010010,
        0b00010001,
        0b00011111,
        0b00000110,
        0b00000011
        };
*/
	DDRB = 255; //all 8 pins are output... the "tiny"2313 has too many pins. But the tiny13 has no hardware uart and only 1k flash and this code takes up 1,1k.
	//OK now we got it: One bicolor (red/green) LED, visible to the outside world and one (color wurscht) LED for PC Uplink (lights when RTS down or RxD)
	//The bicolor LED should show: RED (after power on, no mouse, no PC connection), YELLOW (both on: Mouse detected, no PC connection), GREEN (everything OK)
	//the red portion of the LED is connected to PinB.2,  so we don't have to change ps2.c, green is connected to PinB.1 and the hidden Debug RTS/RxD LED is on PinB.0
	//light Power LED red. (@self: remember that Pin low=LED lights!)
	PORTB = 0xFB;

  devid=0; click=0;
  warhigh=0;
  
  resolution=1;
  
  ps2_gohi(_ps2clk);
  ps2_gohi(_ps2data);
  
	/*
	if(value==HIGH)
	{
		PORTD |= (1<<pin);
	}else
	{
		PORTD &= ~(1<<pin);
	}*/

  //lcd_init();
 
  // Die Ausgabemarke in die 2te Zeile setzen
  //lcd_setcursor( 0, 2 );
 
  // erneut Text ausgeben, aber diesmal komfortabler als String
  //lcd_string("Hello World!");
  
  ps2_gohi(0); //RxD //OK since the ATTINY has PD0 and PD1 here, you have to manually set them as input... makes the code more portable :-(
  ps2_gohi(1); //TxD
  
  //PORTB=0xFF; //all off DEBUG
  uart_init();
  //PORTB=0xFE; //DEBUG
  
/*  PORTB&=0xFE; //LED 1 (which should be hidden from the user) on  
  uart_puts("Hello World!"); //to check if the baud rate is correct on Attiny running at unknown speed (probably 8 MHz, but only probably)
  uart_putc(13); //CR
  uart_putc(10); //LF
  PORTB=0xFB; //and back off
*/
//  lcd_generatechar(LCD_GC_CHAR0, chrdata0);

  
// lcd_home();
// lcd_data('?');
// lcd_data('?');
 
 //Init mouse
 //devid = ps2_init();
  _delay_ms(1);


 ps2_golo(_ps2data);
 _delay_us(40); //30-50
 ps2_gohi(_ps2data);
  //_delay_us(20); //mouse sends "HHHHHLHHHHH", then after a break "LHHHHHLLLLLH". First time, it's 11 bits, but the start bit is H, it should be L, second time it's 12 bits but it should be 11. But o'scope tells me something that looks more like F5h
 while(devid!=0xaa00) //wait for mouse to send "Hello I work and I'm a mouse".
 {
	//lcd_home();
	
	devid=my_ps2read(2);
//	uart_putc(':');
	//itoa(devid, Buffer, 16);
	//lcd_string(Buffer);
//	uart_puts(Buffer);
//	uart_putc(13);
//	uart_putc(10); //btw. the order is wurscht.
	if(devid==0)
	{
		//PORTB &= 0xFB; //error on. For some mice, this will light for a looong time (~0,2 seconds)
		a++;
		//lcd_data('E');
		//lcd_data(a);
		ps2_golo(_ps2data);
		_delay_us(40); //30-50
		ps2_gohi(_ps2data);
		if(a>10)
		{
			my_ps2write(0xFF); //if it's not doing what it should, try to reset the rodent.
			if(my_ps2read(1)!=0xFA) 
			{
				//lcd_string("not responding"); //if it responds to reset, next should be aa00.
				_delay_ms(500);
			}
			//a=0;
		}
	}
 }
 PORTB = 0xF9; //Power LED YELLOW, to show mouse was detected.
 //lcd_home();
 //lcd_string("Juhu!");
// lcd_data(LCD_GC_CHAR0); //display mouse cursor after initialize succeeds.
 //lcd_data(devid+48); //so 0 equals 48 which is ascii 0. I expect values of 0, 3 or 4.
 
 /*
 //TODO now wait for RTS (which still needs to be connected) to get low.
 */
 c=0; //digitalRead(3) is the right pin
 ps2_gohi(3); 
 
 //diesen Teil sollte man auskommentieren
 /*
 while(c<2)
 { //OK Problem: HIGH doesn't work. You must ALWAYS ask for LOW.
	st=digitalRead(3);
	if(st != LOW) c=1; //sorry for that strange structure, but if I write (while(digitalRead(3)==HIGH); while(digitalRead(3)==LOW);) it will run right through.
	if((st == LOW)&&c==1) {c=2; PORTB &=0xFE;} 
//	lcd_setcursor(3,1);
	//if(st==LOW) lcd_data('0'); else lcd_data('1');
 }
 _delay_ms(13);
 uart_putc('M'); //tell the PC that there's a mouse connected.
 PORTB = 0xFD; //only green Power LED on
 */
/* chrdata0[0]=0b00000000;
 chrdata0[1]=0b00000000;
 chrdata0[2]=0b00000000;
 chrdata0[3]=0b00001010;
 chrdata0[4]=0b00010001;
 chrdata0[5]=0b00011111;
 chrdata0[6]=0b00010001;
 chrdata0[7]=0b00001010;
 lcd_generatechar(LCD_GC_CHAR1, chrdata0);
 lcd_setcursor(2,1);
 lcd_data(1);
 */
 
 x=0;
 y=0;
  while(1)
  {
	//char Buffer[4];
	c=uart_kbhit();
	if(c>0)
	{
		//lcd_data(c); //the mouse driver sends some stuff, probably the baud rate offers. Since I cannot set BAUD_RATE while running, I'm stuck to 1200 Baud.
		PORTB &= 0xFE; //flash PC LED to show traffic. Good for debug measures.
	}else PORTB |= 1;
	
	if(digitalRead(3) == LOW && warhigh==1) //Every time an appliance wants to get the mouse, it pulls RTS low and hopes for an 'M'.
	{ //hmmm problem: some programs and some PCs pull RTS low ALL THE TIME!
	//I should first attempt a falling edge trigger (warhigh=washigh so now we have one and it SEEMS to work - still needs lotsa testing)
		//my_ps2write(0xF6); not the best idea - the mouse was buttslow afterwards.
		//my_ps2read(1);
		//lcd_setcursor(10,1);
		//lcd_data('r');
		warhigh=0;
/*		while(digitalRead(3)==LOW)
		{
			fucktimer++;
			_delay_ms(1);
			if(fucktimer>10) break;
		}
*/		//_delay_ms(13);
		_delay_ms(1);
		PORTB &= 0xFE; //Debug LED on
		uart_putc('M');
	}else{
		PORTB|=1;
	}
	if(digitalRead(3) != LOW) warhigh=1;
	my_ps2write(0xeb);
	devid=my_ps2read(4); //some mice send 4 plus ack. I just ignore, if there's more. But wheelmice have to be initialized by a huge string of seemingly random sample rate/resolution commands.
	y=~devid&0xFF; //ignore minus sign since it's 2's complement anyway so if the mouse is moved 1 pixel left, it sends -1=0xFF adding this to an 8 bit value efficiently ... subtracts and we can completely ignore the flag.
	x=(devid&0xFF00)>>8;
	y++; //so we get 0 instead of 255 when there's no movement
/*	lcd_home();
	lcd_string("X:");
	itoa(x, Buffer, 10);
	lcd_string(Buffer);
	lcd_data(' ');
	lcd_setcursor(0,2);
	itoa(y,Buffer,10);
	lcd_string("Y:");
	lcd_string(Buffer);
	lcd_data(' ');
*/	st=devid>>16;
	//lcd_setcursor(8,1);			
	//if(st&1) lcd_data('L');
	//if(st&2) lcd_data('R');
	//if(st&4) lcd_data('M');
	
	if((devid&0xF7FFFF)>0) //only send packet if movement or mouse button (some rare microsoft 3 button mice send Zero Movement+Zero Buttons packets to toggle(!) middle button)
	{
		out=64;
		out|=((st&1)<<5);
		out|=((st&2)<<3); //realign mousebuttons (l&r are swapped)
		out|=((y&0xC0)>>4); //upper 2 y bits
		out|=((x&0xC0)>>6); //upper 2 x bits
		if((st&4)&&click!=2&&(devid&0xFFFF)==0) //middle button has been pressed - so far: Change resolution.
		{
			PORTB |= 0xf0;
			resolution++;
			if(resolution&1) PORTB &=0xef;
			if(resolution&2) PORTB &=0xdf;
			if(resolution>3) resolution=0;
			click=2;
			my_ps2write(0xE8);
			if(my_ps2read(1)==0xFA) //I was gonna bet this was not gonna work. I was wrong.
			{
				my_ps2write(resolution);
				my_ps2read(1);
			}
		
		}
		if(out>64) click=1; //I know it's kinda inefficient to keep on sending Zero Packets with Mouse Button on while Mouse button pressed.
		uart_putc(out);
		out=x&0x3F;
		uart_putc(out);
		out=y&0x3F;
		uart_putc(out);
		//btw. I don't need to care about positive/negative numbers, since PS2 already has them in 2's complements.
	}else
	{
		if(click!=0) //send a 'Button has been released' packet.
		{
			out=64;
			uart_putc(out);
			uart_putc(0);
			uart_putc(0);
			click=0;
		}
	}
	if(click!=0) PORTB &= 0xF7; else PORTB|=8; //another pin good for debug use.

	//_delay_ms(10); //well 100 measurements/sec should do. but now we have uart@1200 baud which is slow as shit and will definitely give the mouse time to recover
	

  }
 
  return 0;
}

/* OK let's put in some quotes from the ps2protocol:
Data high Clk high = IDLE
Data high Clk low = Communication inhibited ("please don't send")
Data low Clk high = Host (PC/C) request to send
11-12 bits:
1 start bit=0
8 data bits lsb first
1 parity bit
1 stop bit=1
(1 ack bit which only comes from the host) (seems to be implemented here)
Parity=inverted 0 means odd 1 means even - usually it's the other way round
clock hi/lo for 30-50S - read data about 20S after clk went LO (if clk=high, data=invalid/transitive)

And here the microsoft serial protocol:
1200 Baud, 7 Bits, 1 Stop bit, no parity. So 7N1. Fuck. How do I send 7 instead of 8 bits? And my dumb terminal supports 7 bits with 4 kinds of parity. None is none of them.

To check for serial mouse:
Pull RTS low and raise it again. After 14 ms, mouse sends 'M'. RTS seems crucial, I have a mouse here with a broken wire, all work except RTS and it's not getting detected.
movement:positive=right, down. PS2 positive=right, up, so you have to ~x before sending.
RTS is now connected to PD3, so digitalRead(3) should yield its state.

			D6	D5	D4	D3	D2	D1	D0
1st byte	1	LB	RB	Y7	Y6	X7	X6
2nd byte	0	X5	X4	X3	X2	X1	X0
3rd byte	0	Y5	Y4	Y3	Y2	Y1	Y0
http://manpages.ubuntu.com/manpages/dapper/man4/mouse.4.html
*/